/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 * 
 * Contributor(s):
 * 
 * Portions Copyrighted 2008 Sun Microsystems, Inc.
 */

package org.netbeans.modules.soa.pojo.wizards;

import javax.swing.JPanel;

public final class POJOProviderAdvancedOptions extends JPanel {
    
    private boolean bSaved = false;

    /** Creates new form POJOProviderVisualPanel2 */
    public POJOProviderAdvancedOptions() {
        initComponents();
    }

    @Override
    public String getName() {
        return "Configure Default Values";
    }
    
    public String getEndpointName() {
        return this.txtEndpointName.getText();
    }
    public void setEndpointName( String data) {
        this.txtEndpointName.setText(data);
    }    
    
    public String getInterfaceName() {
        return this.txtInterfaceName.getText();
    }
    public void setInterfaceName( String data) {
        this.txtInterfaceName.setText(data);
    }    

    public String getInterfaceNameNS() {
        return this.txtInterfaceNs.getText();
    }
    public void setInterfaceNameNS( String data) {
        this.txtInterfaceNs.setText(data);
    }    

    public String getServiceName() {
        return this.txtServiceName.getText();
    }
    public void setServiceName( String data) {
        this.txtServiceName.setText(data);
    } 

    public String getServiceNameNS() {
        return this.txtServiceNs.getText();
    }
    public void setServiceNameNS( String data) {
        this.txtServiceNs.setText(data);
    }    

    public String getOutMessageType() {
        return this.txtOutMsgType.getText(); 
    }
    
    public String getOutMessageTypeNS() {
        return this.txtOutMsgTypeNs.getText(); 
    }    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        txtEndpointName = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        txtInterfaceName = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        txtInterfaceNs = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtServiceName = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtServiceNs = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        txtOutMsgType = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        txtOutMsgTypeNs = new javax.swing.JTextField();
        btOK = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel1.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel1, gridBagConstraints);

        txtEndpointName.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtEndpointName.text")); // NOI18N
        txtEndpointName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtEndpointNameActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtEndpointName, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel2.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel2, gridBagConstraints);

        txtInterfaceName.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtInterfaceName.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtInterfaceName, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel3, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel3.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel3, gridBagConstraints);

        txtInterfaceNs.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtInterfaceNs.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtInterfaceNs, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel4, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel4.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel4, gridBagConstraints);

        txtServiceName.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtServiceName.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtServiceName, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel5, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel5.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel5, gridBagConstraints);

        txtServiceNs.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtServiceNs.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtServiceNs, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel6, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel6.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel6, gridBagConstraints);

        txtOutMsgType.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtOutMsgType.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtOutMsgType, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel7, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.jLabel7.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(jLabel7, gridBagConstraints);

        txtOutMsgTypeNs.setText(org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderVisualPanel2.txtOutMsgTypeNs.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 12, 5);
        add(txtOutMsgTypeNs, gridBagConstraints);

        org.openide.awt.Mnemonics.setLocalizedText(btOK, org.openide.util.NbBundle.getMessage(POJOProviderAdvancedOptions.class, "POJOProviderAdvancedOptions.btOK.text")); // NOI18N
        btOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btOKActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(btOK, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

private void txtEndpointNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtEndpointNameActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_txtEndpointNameActionPerformed

private void btOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btOKActionPerformed
// TODO add your handling code here:
    bSaved = true;
}//GEN-LAST:event_btOKActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btOK;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JTextField txtEndpointName;
    private javax.swing.JTextField txtInterfaceName;
    private javax.swing.JTextField txtInterfaceNs;
    private javax.swing.JTextField txtOutMsgType;
    private javax.swing.JTextField txtOutMsgTypeNs;
    private javax.swing.JTextField txtServiceName;
    private javax.swing.JTextField txtServiceNs;
    // End of variables declaration//GEN-END:variables
}

