/*
 * PreparedStatementPanel.java
 *
 * Created on August 11, 2008, 11:37 AM
 */
package org.netbeans.modules.jdbcwizard.wizards;

import java.awt.Component;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.DefaultTableModel;
import org.openide.WizardDescriptor;
import org.openide.util.Exceptions;
import org.openide.util.HelpCtx;

import org.netbeans.api.db.explorer.DatabaseConnection;
import org.netbeans.api.db.explorer.ConnectionManager;
import org.netbeans.modules.jdbcwizard.builder.DBMetaData;
import org.netbeans.modules.jdbcwizard.builder.PrepStmt;
import org.netbeans.modules.jdbcwizard.builder.Parameter;
import org.netbeans.modules.jdbcwizard.builder.ResultSetColumn;

/**
 *
 * @author  pponnala
 */
public class PreparedStatementPanel extends javax.swing.JPanel implements WizardDescriptor.Panel {
    private DefaultTableModel paramsModel;
    private DefaultTableModel resultsetModel;

    /** Creates new form PreparedStatementPanel */
    public PreparedStatementPanel() {
        paramsModel = new DefaultTableModel(new Object[] {"Parameter Name", "Parameter Type"}, 0);
        resultsetModel = new DefaultTableModel(new Object[] {"Column Name", "Column Type"}, 0);
        initComponents();
    }

    PreparedStatementPanel(String title) {
        this();
        if (title != null && title.trim().length() != 0) {
            this.setName(title);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        preparedStmtTxtArea = new javax.swing.JTextArea();
        prepStmtLabel = new javax.swing.JLabel();
        jbtnFindParams = new javax.swing.JButton();
        jbtnFindParams.setText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindParams.text"));
        jScrollPane2 = new javax.swing.JScrollPane();
        paramsTable = new javax.swing.JTable();
        prepStatementEditorLabel = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        resultsetTable = new javax.swing.JTable();
        jbtnFindResultset = new javax.swing.JButton();
        paramsLabel = new javax.swing.JLabel();
        resultsetsLabel = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        statusText = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();

        preparedStmtTxtArea.setColumns(20);
        preparedStmtTxtArea.setFont(preparedStmtTxtArea.getFont());
        preparedStmtTxtArea.setRows(5);
        preparedStmtTxtArea.setText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.preparedStmtTxtArea.text")); // NOI18N
        preparedStmtTxtArea.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.preparedStmtTxtArea.toolTipText")); // NOI18N
        preparedStmtTxtArea.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                preparedStmtTxtAreaKeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(preparedStmtTxtArea);
        preparedStmtTxtArea.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStmtLabel.AccessibleContext.accessibleName")); // NOI18N
        preparedStmtTxtArea.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStmtLabel.AccessibleContext.accessibleDescription")); // NOI18N

        prepStmtLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        prepStmtLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        prepStmtLabel.setLabelFor(preparedStmtTxtArea);
        org.openide.awt.Mnemonics.setLocalizedText(prepStmtLabel, org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStmtLabel.text")); // NOI18N
        prepStmtLabel.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStmtLabel.toolTipText")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jbtnFindParams, org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindParams.text")); // NOI18N
        jbtnFindParams.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindParams.toolTipText")); // NOI18N
        jbtnFindParams.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findParamsActionPerformed(evt);
            }
        });

        paramsTable.setFont(new java.awt.Font("Tahoma", 1, 12));
        paramsTable.setModel(paramsModel);
        paramsTable.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.paramsTable.toolTipText")); // NOI18N
        paramsTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        paramsTable.setColumnSelectionAllowed(true);
        jScrollPane2.setViewportView(paramsTable);
        paramsTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        paramsTable.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.paramsTable.AccessibleContext.accessibleName")); // NOI18N
        paramsTable.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.paramsTable.AccessibleContext.accessibleDescription")); // NOI18N

        prepStatementEditorLabel.setFont(new java.awt.Font("Tahoma", 1, 14));
        prepStatementEditorLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        prepStatementEditorLabel.setText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStatementEditorLabel.text")); // NOI18N

        resultsetTable.setFont(new java.awt.Font("Tahoma", 1, 12));
        resultsetTable.setModel(resultsetModel);
        resultsetTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        resultsetTable.setColumnSelectionAllowed(true);
        jScrollPane4.setViewportView(resultsetTable);
        resultsetTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);

        org.openide.awt.Mnemonics.setLocalizedText(jbtnFindResultset, org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindResultset.text")); // NOI18N
        jbtnFindResultset.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindResultset.toolTipText")); // NOI18N
        jbtnFindResultset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnfindResultsetActionPerformed(evt);
            }
        });

        paramsLabel.setFont(paramsLabel.getFont().deriveFont(paramsLabel.getFont().getStyle() | java.awt.Font.BOLD, paramsLabel.getFont().getSize()+1));
        paramsLabel.setLabelFor(paramsTable);
        org.openide.awt.Mnemonics.setLocalizedText(paramsLabel, org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.paramsLabel.text")); // NOI18N

        resultsetsLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        resultsetsLabel.setLabelFor(resultsetTable);
        org.openide.awt.Mnemonics.setLocalizedText(resultsetsLabel, org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.resultsetsLabel.text")); // NOI18N
        resultsetsLabel.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.resultsetsLabel.toolTipText")); // NOI18N

        statusText.setBackground(javax.swing.UIManager.getDefaults().getColor("Panel.background"));
        statusText.setColumns(20);
        statusText.setFont(statusText.getFont());
        statusText.setRows(5);
        statusText.setToolTipText(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.statusText.toolTipText")); // NOI18N
        jScrollPane3.setViewportView(statusText);
        statusText.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.statusText.AccessibleContext.accessibleName")); // NOI18N
        statusText.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.statusText.AccessibleContext.accessibleDescription")); // NOI18N

        jLabel1.setFont(jLabel1.getFont().deriveFont(jLabel1.getFont().getStyle() | java.awt.Font.BOLD, jLabel1.getFont().getSize()+1));
        jLabel1.setLabelFor(statusText);
        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jLabel1.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(125, 125, 125)
                        .add(prepStatementEditorLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 453, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(prepStmtLabel)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 308, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 316, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(layout.createSequentialGroup()
                                        .add(16, 16, 16)
                                        .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 153, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .add(27, 27, 27)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jbtnFindResultset)
                                    .add(jbtnFindParams))))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(paramsLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 92, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(resultsetsLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 92, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 249, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))
                .add(33, 33, 33))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(prepStatementEditorLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 41, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(99, 99, 99)
                        .add(jbtnFindParams, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(prepStmtLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(paramsLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 170, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(36, 36, 36)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createSequentialGroup()
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 92, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(resultsetsLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jbtnFindResultset, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .add(28, 28, 28))
        );

        prepStmtLabel.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStmtLabel.AccessibleContext.accessibleName")); // NOI18N
        prepStmtLabel.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.prepStmtLabel.AccessibleContext.accessibleDescription")); // NOI18N
        jbtnFindParams.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindParams.AccessibleContext.accessibleName")); // NOI18N
        jbtnFindParams.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindParams.AccessibleContext.accessibleDescription")); // NOI18N
        jbtnFindResultset.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindResultset.AccessibleContext.accessibleName")); // NOI18N
        jbtnFindResultset.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.jbtnFindResultset.AccessibleContext.accessibleDescription")); // NOI18N
        resultsetsLabel.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.resultsetsLabel.AccessibleContext.accessibleName")); // NOI18N
        resultsetsLabel.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(PreparedStatementPanel.class, "PreparedStatementPanel.resultsetsLabel.AccessibleContext.accessibleDescription")); // NOI18N
    }// </editor-fold>//GEN-END:initComponents

private void findParamsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findParamsActionPerformed
    try {        
        //reset the parameters first
    	while(paramsModel.getRowCount() > 0){
    		paramsModel.removeRow(0);
        }
        statusText.setText("");
        sqlText = preparedStmtTxtArea.getText();
        prepStmt = dbMeta.getPrepStmtMetaData(conn.getJDBCConnection().getCatalog(), conn.getSchema(), null, sqlText, conn.getJDBCConnection());
        params = prepStmt.getParameters();
        for (int i = 0; i < prepStmt.getNumParameters(); i++) {
            paramsModel.addRow(new Object[] {params[i].getName(), params[i].getJavaType()});
        }
        paramsTable.setVisible(true);
        if(!isValidSql()){
            statusText.setText("Status: Please enter a valid SQL. Only DML Statements are supported");
        }
        fireChangeEvent();

    } catch (SQLException sqle) {
        statusText.setText("Status: Error executing the entered SQL:" + sqle.getMessage());
    } catch (Exception ex) {
        ex.printStackTrace();
    }
}//GEN-LAST:event_findParamsActionPerformed

private void preparedStmtTxtAreaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_preparedStmtTxtAreaKeyPressed
        sqlText = preparedStmtTxtArea.getText();
        fireChangeEvent();
}//GEN-LAST:event_preparedStmtTxtAreaKeyPressed

private void jbtnfindResultsetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnfindResultsetActionPerformed
        
    try {
        //reset the parameters first
        while(resultsetModel.getRowCount()>0 ) {
            resultsetModel.removeRow(0);
        }
        statusText.setText("");
        sqlText = preparedStmtTxtArea.getText();
        prepStmt = dbMeta.getPrepStmtMetaData(conn.getJDBCConnection().getCatalog(), conn.getSchema(), null, sqlText, conn.getJDBCConnection());
        resultset = prepStmt.getResultSetColumns();
        for (int i = 0; i < prepStmt.getNumResultSetColumns(); i++) {
            resultsetModel.addRow(new Object[] {resultset[i].getName(), resultset[i].getJavaType()});
        }
        resultsetTable.setVisible(true);
        if(!isValidSql()){
            statusText.setText("Status: Please enter a valid SQL. Only DML Statements are supported");
        }
        fireChangeEvent();

    } catch (SQLException sqle) {
        statusText.setText("Status: Error executing the entered SQL:" + sqle.getMessage());
    } catch (Exception ex) {
        ex.printStackTrace();
    }
}//GEN-LAST:event_jbtnfindResultsetActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JButton jbtnFindParams;
    private javax.swing.JButton jbtnFindResultset;
    private javax.swing.JLabel paramsLabel;
    private javax.swing.JTable paramsTable;
    private javax.swing.JLabel prepStatementEditorLabel;
    private javax.swing.JLabel prepStmtLabel;
    private javax.swing.JTextArea preparedStmtTxtArea;
    private javax.swing.JTable resultsetTable;
    private javax.swing.JLabel resultsetsLabel;
    private javax.swing.JTextArea statusText;
    // End of variables declaration//GEN-END:variables
    private DatabaseConnection conn;
    private DBMetaData dbMeta;
    private PrepStmt prepStmt;
    private String sqlText;
    private final List /* <ChangeListener> */ listeners = new ArrayList();

    private ResultSetColumn[] resultset;
    private Parameter[] params;
    private boolean isValidSql = false;

    public Component getComponent() {
        return this;
    }

    public HelpCtx getHelp() {
        return new HelpCtx(PreparedStatementPanel.class);
    }

    public void readSettings(Object settings) {
        WizardDescriptor wd = null;
        if (settings instanceof JDBCWizardContext) {
            final JDBCWizardContext wizardContext = (JDBCWizardContext) settings;
            wd = (WizardDescriptor) wizardContext.getProperty(JDBCWizardContext.WIZARD_DESCRIPTOR);

        } else if (settings instanceof WizardDescriptor) {
            wd = (WizardDescriptor) settings;
        }

    }

    public void fireChangeEvent() {
        Iterator it;

        synchronized (this.listeners) {
            it = new HashSet(this.listeners).iterator();
        }

        final ChangeEvent ev = new ChangeEvent(this);
        while (it.hasNext()) {
            ((ChangeListener) it.next()).stateChanged(ev);
        }
    }

    public void storeSettings(Object arg0) {
    }

    public void addChangeListener(ChangeListener l) {
        this.listeners.add(l);
    }

    public void removeChangeListener(ChangeListener l) {
        this.listeners.remove(l);
    }

    public void setConnection(DatabaseConnection dbConn) {
        this.conn = dbConn;
    }

    @Override
    public boolean isValid() {
        if((sqlText != null) && !(sqlText.equalsIgnoreCase(""))) {
            return true;
        }
        return false;
    }
    
    public String getSQL(){
    	return sqlText;
    }
    
    public void setTextArea(String sql){
    	this.preparedStmtTxtArea.setText(sql);
    }
    
    public PrepStmt getPrepStmt(){
    	return this.prepStmt;
    }
    
    private boolean isValidSql(){
    	if(this.sqlText.trim()!= null){
        StringTokenizer st = new StringTokenizer(sqlText.toUpperCase());

        if (st.hasMoreTokens()) {
        	String token =st.nextToken();
        	if(token.equalsIgnoreCase("SELECT") || token.equalsIgnoreCase("INSERT") || token.equalsIgnoreCase("UPDATE") || token.equalsIgnoreCase("DELETE")){
        		isValidSql=true;
        	} else{
        		isValidSql=false;
        	}
        }
    	}
        return isValidSql;
    }
    
}
