/*
 * ProcedureParametersDialog.java
 *
 * Created on August 21, 2008, 11:54 AM
 */

package org.netbeans.modules.jdbcwizard.wizards;

import javax.swing.table.DefaultTableModel;
import org.netbeans.modules.jdbcwizard.builder.DBMetaData;
import org.netbeans.modules.jdbcwizard.builder.Procedure;
import org.netbeans.modules.jdbcwizard.builder.Parameter;
/**
 *
 * @author  pponnala
 */
public class ProcedureParametersDialog extends javax.swing.JDialog {

    private DefaultTableModel procParameterModel;
    private Procedure selectedProc;
    private DBMetaData dbMeta;
    private StoredProceduresPanel caller;
    
    /** Creates new form ProcedureParametersDialog */
    public ProcedureParametersDialog(java.awt.Dialog parent, boolean modal) {
        super(parent, modal);
        procParameterModel = new DefaultTableModel(new Object[] {"Index", "Name", "Type","ParameterType"}, 0);                
        initComponents();
    }

    public void setSelectedProc(Procedure proc) {
        this.selectedProc = proc;
        if (procParameterModel != null) {
            while (procParameterModel.getRowCount() > 0) {
                procParameterModel.removeRow(0);
            }
        }
        Parameter[] params = selectedProc.getParameters();
        if ((params != null) && params.length > 0) {
            for(Parameter param : params) {
                procParameterModel.addRow(new Object[] {String.valueOf(param.getOrdinalPosition()),
                                                        param.getName(),
                                                        param.getSqlType(),
                                                        param.getParamType()}
                                    );
            }
        }
    }

    void setCaller(StoredProceduresPanel aThis) {
        this.caller = aThis;
    }

    void setMetaDataObject(DBMetaData dbMeta) {
        this.dbMeta = dbMeta;
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        procNameLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        procParamsTable = new javax.swing.JTable();
        btnOK = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        procNameLabel.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        procNameLabel.setLabelFor(procParamsTable);
        org.openide.awt.Mnemonics.setLocalizedText(procNameLabel, org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.procNameLabel.text")); // NOI18N

        procParamsTable.setFont(procParamsTable.getFont());
        procParamsTable.setModel(procParameterModel);
        procParamsTable.setToolTipText(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.procParamsTable.toolTipText")); // NOI18N
        jScrollPane1.setViewportView(procParamsTable);
        procParamsTable.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.procParamsTable.AccessibleContext.accessibleName")); // NOI18N
        procParamsTable.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.procParamsTable.AccessibleContext.accessibleDescription")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(btnOK, org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnOK.text")); // NOI18N
        btnOK.setToolTipText(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnOK.toolTipText")); // NOI18N
        btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOKActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(btnCancel, org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnCancel.text")); // NOI18N
        btnCancel.setToolTipText(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnCancel.toolTipText")); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(procNameLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 180, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 375, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createSequentialGroup()
                        .add(88, 88, 88)
                        .add(btnOK, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 86, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(27, 27, 27)
                        .add(btnCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 88, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(66, Short.MAX_VALUE))
        );

        layout.linkSize(new java.awt.Component[] {btnCancel, btnOK}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(procNameLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 275, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnOK, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(new java.awt.Component[] {btnCancel, btnOK}, org.jdesktop.layout.GroupLayout.VERTICAL);

        btnOK.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnOK.AccessibleContext.accessibleName")); // NOI18N
        btnOK.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnOK.AccessibleContext.accessibleDescription")); // NOI18N
        btnCancel.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(ProcedureParametersDialog.class, "ProcedureParametersDialog.btnCancel.AccessibleContext.accessibleDescription")); // NOI18N

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOKActionPerformed
//set resultset model back in the proc
    //close
    doClose();
}//GEN-LAST:event_btnOKActionPerformed

private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
// TODO add your handling code here:
    doClose();//GEN-LAST:event_btnCancelActionPerformed
}

    private void doClose() {
        procParamsTable.removeAll();
        setVisible(false);
        dispose();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOK;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel procNameLabel;
    private javax.swing.JTable procParamsTable;
    // End of variables declaration//GEN-END:variables

}
