/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 1997-2009 Sun Microsystems, Inc.
 */

package org.netbeans.modules.wlm.bridge.wizard;

import java.util.Enumeration;
import java.util.Iterator;
import javax.swing.JPanel;
import org.netbeans.modules.worklist.editor.spi.WSDLProvider;
import org.openide.filesystems.FileObject;

public final class WLMVisualPanel1 extends JPanel {

    public static String DEFAULT_TASK_NAME = "NewWLMTask";
    public static String DEFAULT_PROJECT_NAME = "WLMTaskModule";
    public static String PROJECT_LOCATION = "projectLocation";
    public static String J2EE_LEVEL = "j2eeLevel";
    private FileObject sourceLocation;

    /** Creates new form WLMVisualPanel1 */
    WLMVisualPanel1(FileObject sourceLocation) {
        this.sourceLocation = sourceLocation;
        initComponents();
        initGUI();
    }

    @Override
    public String getName() {
        return "Create New Task";
    }

    public String getTaskName() {
        return tfTaskName.getText();
    }

    public String getProjectName() {
        return tfProjectName.getText();
    }

    public String getProjectLocation() {
        return tfProjectLocation.getText();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        tfProjectName = new javax.swing.JTextField();
        jButton7 = new javax.swing.JButton();
        tfTaskName = new javax.swing.JTextField();
        jButton8 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        tfProjectLocation = new javax.swing.JTextField();
        this.tfProjectLocation.setText(sourceLocation.getPath());

        org.openide.awt.Mnemonics.setLocalizedText(jLabel13, org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.jLabel13.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel5, org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.jLabel5.text")); // NOI18N

        tfProjectName.setText(org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.tfProjectName.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jButton7, org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.jButton7.text")); // NOI18N

        tfTaskName.setText(org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.tfTaskName.text")); // NOI18N
        tfTaskName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfTaskNameActionPerformed(evt);
            }
        });
        tfTaskName.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tfTaskNameKeyReleased(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jButton8, org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.jButton8.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.jLabel1.text")); // NOI18N

        tfProjectLocation.setText(org.openide.util.NbBundle.getMessage(WLMVisualPanel1.class, "WLMVisualPanel1.tfProjectLocation.text")); // NOI18N
        tfProjectLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfProjectLocationActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel13)
                    .add(jLabel5)
                    .add(jLabel1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(tfProjectLocation, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 387, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton7))
                    .add(tfProjectName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 236, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(tfTaskName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 131, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton8)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(75, 75, 75)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tfTaskName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton8)
                    .add(jLabel5))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel13)
                    .add(tfProjectName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jButton7)
                    .add(tfProjectLocation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(80, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(33, 33, 33)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(34, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void initGUI() {
        setTaskName();
        setProjectName();
        setProjectLocation();
    }

private void tfTaskNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfTaskNameActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_tfTaskNameActionPerformed

private void tfProjectLocationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfProjectLocationActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_tfProjectLocationActionPerformed

private void tfTaskNameKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tfTaskNameKeyReleased
    setProjectName();
}//GEN-LAST:event_tfTaskNameKeyReleased

    private int getNameIndex() {
        FileObject parent = sourceLocation.getParent();
        
        String projectName = DEFAULT_PROJECT_NAME;
        
        String taskName = DEFAULT_TASK_NAME;
// BACKUP        
//        String taskFileNameEnd = WSDLProvider.WSDL_SUFFIX + "." // NOI18N
//                + WSDLProvider.WSDL_EXT;
//        String taskFileNameStart = "src/"; // NOI18N
        String taskFileNameEnd = ""; // NOI8N
        String taskFileNameStart = "src/services/"; // NOI18N
        String taskFileName = taskFileNameStart + taskName + taskFileNameEnd;

        int nameIndex = 0;
        
        if (sourceLocation.getFileObject(taskFileName) != null 
                || parent.getFileObject(projectName) != null) 
        {
            do {
                nameIndex++;
                taskName = DEFAULT_TASK_NAME + nameIndex;
                taskFileName = taskFileNameStart + taskName + taskFileNameEnd;
                projectName = DEFAULT_PROJECT_NAME + nameIndex;
            } while (sourceLocation.getFileObject(taskFileName) != null 
                    || parent.getFileObject(projectName) != null);
        } 

        return nameIndex;
    }

    private void setTaskName() {
        String taskName = DEFAULT_TASK_NAME;
        int index = getNameIndex();
        if (index > 0) {
            taskName += index;
        }
        this.tfTaskName.setText(taskName);
    }
    
    private void setProjectName() {
        FileObject foParent = sourceLocation.getParent();
        String projectName = getProjectName(foParent, DEFAULT_PROJECT_NAME + "1");
        this.tfProjectName.setText(projectName);
    }

    private String getProjectName(FileObject foParent, String projectName) {
        if (foParent.getFileObject(projectName, null) == null) {
            return projectName;
        } else {
            Integer projIntSuffix = Integer.valueOf(projectName.substring(DEFAULT_PROJECT_NAME.length()));
            return getProjectName(foParent, DEFAULT_PROJECT_NAME + (projIntSuffix.intValue() + 1));
        }
    }

    private void setProjectLocation() {
        String locationPath = this.sourceLocation.getParent().getPath();
        this.tfProjectLocation.setText(locationPath);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextField tfProjectLocation;
    private javax.swing.JTextField tfProjectName;
    private javax.swing.JTextField tfTaskName;
    // End of variables declaration//GEN-END:variables
}

